/* GGI initialisation, most code is Copyright (C) W.H.Scholten 1998   [-*- C++ -*-]
 */

#include <stdio.h> 
#include <signal.h>
#include <ggi/libggi.h>

#include "dtypes.h"
#include "macsys.h"
#include "grdef.h"
#include "gr.h"
#include "palette.h"
#include "mem.h"
#include "key.h"


#include "debug.h"


int  MonitorRowBytes;			// bytes per row for current graphics mode (including non-visible part!), should rename to 'grmode_bytes_per_row' (used in sysmacwin.c, sys/macsys.h, 2d/gr.c)

int  error_code;
int  full_width, full_height;
int  display_type, display_depth, bpp, Bpp;

//GGI specific:
ggi_visual_t		visual;
ggi_directbuffer_t		dbuf;	// GGI direct acces to screen memory
ggi_pixellinearbuffer	*plb;

bool libggi_init, visual_open, mode_switched;



ubyte Compatibility_mode = 0;	// compatibility mode using copybits?
/* used in game.c/macwin.c: What is copybits? get rid of it? */

int  GWorldWidth, GWorldHeight; //used in scrncpy.c/macwin.c


//called in 2d/gr.c
void set_win_size(int x, int y, int w, int h)
{
	GWorldWidth = w;
	GWorldHeight = h;


	//  Size the GameWindow.  We need to be sure that the left edge of the window falls on
	//  a multiple of 8 byte boundry for speed purposes on the direct screen copy.  The new width
	//  will always be some multiple of 16 to ensure that we have a total byte count per row of
	//  some multiple of eight bytes.

	//	if (((x / 8) * 8) != x)
	//		x -= (x % 8);
	//	MoveWindow(GameWindow, x, y, 1);
}

grs_canvas *mac_get_gworld_data(int w, int h)
{
	void *buffer;
	grs_canvas *new;

	int x=0; int y=0;

	buffer = ((byte *) plb->write) + (plb->stride * y)+x;

	new = (grs_canvas *)mymalloc( sizeof(grs_canvas) );

	new->cv_bitmap.bm_x = 0;
	new->cv_bitmap.bm_y = 0;
	new->cv_bitmap.bm_w = w;
	new->cv_bitmap.bm_h = h;
	new->cv_bitmap.bm_flags = 0;
	new->cv_bitmap.bm_type = BM_LINEAR;
//	new->cv_bitmap.bm_rowsize = (**pixmap).rowBytes & 0x3fff;
	new->cv_bitmap.bm_rowsize = plb->stride;

	new->cv_bitmap.bm_data = (ubyte *)buffer;

	new->cv_color = 0;
	new->cv_drawmode = 0;
	new->cv_font = NULL;
	new->cv_font_fg_color = 0;
	new->cv_font_bg_color = 0;
	return new;
}


void macwin_close() {
	if (visual_open) ggiClose(visual);
	if (libggi_init) ggiExit();
}

#define GGI_DISPLAY 3

void segfault_handler(int code) {
	fprintf(stderr, "GGI descent: segfault\n");
	if (libggi_init)
		ggiPanic(NULL);
	else
		exit(128);
}

int macwin_init()
{
	int w,h;

//	key_close();
//	show_cursor();

//	hide_cursor();
//	key_init();


	atexit(&macwin_close);

//	signal(SIGSEGV, &segfault_handler);

	w = 640; h = 480;
//	w = 320; h = 200;

	full_width=w; full_height=h;


	if (ggiInit()) {
	    fprintf(stderr, "GGI: libggi error\n");
	    return -1;
	}
	libggi_init=True;

//	visual = ggiOpen("display-KGI:/dev/graphic", NULL);
	visual = ggiOpen (NULL);
	if (visual==NULL) {
	    fprintf(stderr, "GGI: failed to create visual\n");
	    return -1;
	}
	visual_open=True;

	/* Open our DISPLAY */
	error_code=ggiSetGraphMode(visual, full_width, full_height, full_width, full_height, GT_8BIT);
	if (error_code) {
	    fprintf(stderr, "GGI: Can't set screen mode..\n");
	    return -1;
	}
	mode_switched=True;

	display_type=GGI_DISPLAY;
	display_depth=bpp;

	Bpp=(display_depth+7)/8;


	dbuf=NULL;
	while(1) {
		if (ggiDBGetBuffer (visual, &dbuf) || dbuf==NULL) {
			fprintf(stderr, "GGI: could not find a linear framebuffer\n");
			return -1;
		}
		if (ggiDBGetLayout (dbuf) != blPixelLinearBuffer) continue;
		plb = ggiDBGetPLB(dbuf);
			//We now have the following information available:
			// window width, height at :
			//    plb->size.x, plb->size.y,
			//    plb->origin.x, plb->origin.y,
			// stride (bytes to the next scanline), bpp:
			//    plb->stride, plb->bpp
			// read, write, (paged size):
			//    plb->read, plb->write, plb->page_size
		break;
	}

	MonitorRowBytes = plb->stride;

#if 0
	if (page_flipping_on) {
	    screen_width = plb->stride;
	    ggiSetOrigin(disp, 0, 0);
	    visible_screen = 0;
	    offscreen_buffer = (byte *)plb->write + screen_width*Bpp*screen_height;
	} else {
	    offscreen_buffer = (byte *)malloc(screen_width*Bpp*screen_height);
	}
#endif

	//Async mode, needs changes to work: ggiFlush() after game_render_frame, and in menu's etc, for ASYNC during the game only, you need to switch back to SYNC for menu's (or do lots of ggiFlush'es).
//	ggiSetInfoFlags(visual,GGIFLAG_ASYNC);


	return 0;	
}
